
#ifndef PLS_BARRIER_H
#define PLS_BARRIER_H

#include <pthread.h>

namespace pls {
    namespace internal {
        namespace base {
            class barrier {
                pthread_barrier_t barrier_;

            public:
                explicit barrier(const unsigned int count): barrier_{} {
                    pthread_barrier_init(&barrier_, nullptr, count);
                }

                ~barrier() {
                    pthread_barrier_destroy(&barrier_);
                }

                void wait() {
                    pthread_barrier_wait(&barrier_);
                }
            };
        }
    }
}

#endif //PLS_BARRIER_H
